---
title: Add a Webhook
description: Create a new webhook in the specified space.
url: https://storyblok.com/docs/api/management/webhooks/add-a-webhook
---

# Add a Webhook

POST

```html
https://mapi.storyblok.com/v1/spaces/:space_id/webhook_endpoints
```

Create a new webhook in the specified space.

> [!WARNING]
> This endpoint requires an admin or owner role.

## Path parameters

-   `:space_id` (required) (number)
    
    Numeric ID of a space
    

## Request body properties

-   `webhook_endpoint` (The Webhook Object)
    
    [Webhook object](/docs/api/management/webhooks/the-webhook-object)
    

## Response properties

-   `webhook_endpoint` (The Webhook Object)
    
    [Webhook object](/docs/api/management/webhooks/the-webhook-object)
    

## Examples

-   cURL
    
    ```shellscript
    curl "https://mapi.storyblok.com/v1/spaces/288868932106293/webhook_endpoints/" \
      -X POST \
      -H "Authorization: YOUR_OAUTH_TOKEN" \
      -H "Content-Type: application/json" \
      -d "{\"webhook_endpoint\":{\"actions\":[\"story.published\"],\"activated\":true,\"endpoint\":\"https://apiendpoint.com\",\"name\":\"Rebuild Website\",\"secret\":\"\"}}"
    ```
    
-   JS
    
    ```javascript
    // storyblok-js-client@>=7, node@>=18
    import Storyblok from "storyblok-js-client";
    
    const storyblok = new Storyblok({
      oauthToken: "YOUR_PERSONAL_ACCESS_TOKEN",
    });
    
    try {
      const response = await storyblok.post('spaces/288868932106293/webhook_endpoints/', {
        "webhook_endpoint": {
          "actions": [
            "story.published"
          ],
          "activated": true,
          "endpoint": "https://apiendpoint.com",
          "name": "Rebuild Website",
          "secret": ""
        }
      })
      console.log({ response })
    } catch (error) {
      console.log(error)
    }
    ```
    
-   PHP
    
    ```php
    $client = new \Storyblok\ManagementClient('YOUR_OAUTH_TOKEN');
    
    $payload = ["webhook_endpoint" => ["actions" => ["story.published"],"activated" => true,"endpoint" => "https => //apiendpoint.com","name" => "Rebuild Website","secret" => ""]];
    
    $client->post('spaces/288868932106293/webhook_endpoints/', $payload)->getBody();
    ```
    
-   Java
    
    ```java
    HttpResponse<String> response = Unirest.post("https://mapi.storyblok.com/v1/spaces/288868932106293/webhook_endpoints/")
      .header("Content-Type", "application/json")
      .header("Authorization", "YOUR_OAUTH_TOKEN")
      .body({"webhook_endpoint":{"actions":["story.published"],"activated":true,"endpoint":"https://apiendpoint.com","name":"Rebuild Website","secret":""}})
      .asString();
    ```
    
-   C#
    
    ```csharp
    var client = new RestClient("https://mapi.storyblok.com/v1/spaces/288868932106293/webhook_endpoints/");
    var request = new RestRequest(Method.POST);
    
    request.AddHeader("Content-Type", "application/json");
    request.AddHeader("Authorization", "YOUR_OAUTH_TOKEN");
    request.AddParameter("application/json", "{\"webhook_endpoint\":{\"actions\":[\"story.published\"],\"activated\":true,\"endpoint\":\"https://apiendpoint.com\",\"name\":\"Rebuild Website\",\"secret\":\"\"}}", ParameterType.RequestBody);
    IRestResponse response = client.Execute(request);
    ```
    
-   Python
    
    ```python
    import requests
    
    url = "https://mapi.storyblok.com/v1/spaces/288868932106293/webhook_endpoints/"
    
    querystring = {}
    
    payload = {"webhook_endpoint":{"actions":["story.published"],"activated":true,"endpoint":"https://apiendpoint.com","name":"Rebuild Website","secret":""}}
    headers = {
      'Content-Type': "application/json",
      'Authorization': "YOUR_OAUTH_TOKEN"
    }
    
    response = requests.request("POST", url, data=payload, headers=headers, params=querystring)
    
    print(response.text)
    ```
    
-   Ruby
    
    ```ruby
    require 'storyblok'
    client = Storyblok::Client.new(oauth_token: 'YOUR_OAUTH_TOKEN')
    
    payload = {"webhook_endpoint" => {"actions" => ["story.published"],"activated" => true,"endpoint" => "https => //apiendpoint.com","name" => "Rebuild Website","secret" => ""}}
    
    client.post('spaces/288868932106293/webhook_endpoints/', payload)
    ```
    
-   Swift
    
    ```swift
    let storyblok = URLSession(storyblok: .mapi(accessToken: .oauth("YOUR_OAUTH_TOKEN")))
    var request = URLRequest(storyblok: storyblok, path: "spaces/288868932106293/webhook_endpoints/")
    request.httpMethod = "POST"
    request.httpBody = try JSONSerialization.data(withJSONObject: [
        "webhook_endpoint": [
            "actions": [
                "story.published",
            ],
            "activated": true,
            "endpoint": "https://apiendpoint.com",
            "name": "Rebuild Website",
            "secret": "",
        ],
    ])
    let (data, _) = try await storyblok.data(for: request)
    print(try JSONSerialization.jsonObject(with: data))
    ```
    
-   Kotlin
    
    ```kotlin
    val client = HttpClient {
        install(Storyblok(MAPI)) {
            accessToken = OAuth("YOUR_OAUTH_TOKEN")
        }
    }
    
    val response = client.post("spaces/288868932106293/webhook_endpoints/") {
        setBody(buildJsonObject {
            putJsonObject("webhook_endpoint") {
                putJsonArray("actions") {
                    add("story.published")
                }
                put("activated", true)
                put("endpoint", "https://apiendpoint.com")
                put("name", "Rebuild Website")
                put("secret", "")
            }
        })
    }
    
    println(response.body<JsonElement>())
    ```

## Pagination

-   [Previous: Webhooks](/docs/api/management/webhooks)
-   [Next: Delete a Webhook](/docs/api/management/webhooks/delete-a-webhook)
